/************************
*   Block Manager interface
*  Copyright Pu Bo 2001
*/

#ifndef _BLKMGRIFC_H
#define _BLKMGRIFC_H

#include "BlkDevIfc.h"
#include "DEFINE.h"

/* interface id */
#define IID_BLOCK_MGR LONG_ID('B','L','K','M')
#define INVALID_BLK_IDX ((BlkNum)(-1))

typedef bool (*BlkMgmtProgressCBFunc)(unsigned long maxVal, unsigned long curVal);

/* interface */
typedef struct {
    BlkNum (*AllocateBlock)(BlockDeviceHndl devH);
    void (*FreeBlock)(BlockDeviceHndl devH,BlkNum blkIdx);
    void (*BlockManagement)(BlockDeviceHndl devH);
    bool (*ReserveBlock)(BlockDeviceHndl devH,BlkNum blkNum);
    void (*UnreserveBlock)(BlkNum blkNum);
    void (*SetMgmtProgressCB)(BlockDeviceHndl devH,BlkMgmtProgressCBFunc cb);
    BlkNum (*GetFreeBlocks)(BlockDeviceHndl devH);
}BlockMgrInterface;

typedef BlockMgrInterface far * BlkMgrIfCPtr;

#endif