/**************************************************
** Mini Assert lib Ver 1.0
**
** Copyright Pu Bo 2001, pubo@bigfoot.com
*/
#ifndef _MASSERT_H
#define _MASSERT_H

#ifdef WIN32
#include <assert.h>
#ifndef ASSERT
#define ASSERT assert
#endif
#else
#ifndef DEBUG_MESSAGE
#define DEBUG_MESSAGE 0
#endif
#ifndef DEBUG_CHECK
#define DEBUG_CHECK 0
#endif

void _MAssert(char *);
#if !defined(DEBUG) || !defined(PV3S1600)
#define ASSERT(cond)    ((void)0)
#define CHECK(cond)     ((void)0)
#define DBMSG(msg)      ((void)0)
#else   /* NDEBUG */
#define _qq_(s) #s
#define _q_(s)  _qq_(s)
#define ASSERT(cond)    \
    ((cond) ? (void)0 : \
          _MAssert("Assert Failure!\r\r"#cond "\r\rfile " __FILE__ "\r\rline " _q_(__LINE__)))
#if DEBUG_CHECK
#define CHECK(cond) \
    ((cond) ? (void)0 : \
          _MCheck("Check Failure!\r\r"#cond "\r\rfile " __FILE__ "\r\rline " _q_(__LINE__)))
#else
#define CHECK(cond)     ((void)0)
#endif
void _MCheck(char *);
#if DEBUG_MESSAGE
#define DBMSG(msg)  \
        _MCheck("Debug Message\r\r" msg "\r\rfile " __FILE__ "\r\rline " _q_(__LINE__))
#else
#define DBMSG(msg)      ((void)0)
#endif
#endif  /* DEBUG */

#endif /* WIN32 */
#endif